/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package Controller;

import LoginDb.DbHandler;
import java.io.IOException;
import java.io.PrintWriter;
import java.lang.reflect.InvocationTargetException;
import java.sql.CallableStatement;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import org.apache.commons.beanutils.BeanUtils;
import DataEntryBean.BasicInformationBean;

public class BasicInformationServlet extends HttpServlet {

    /**
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {

        HttpSession session = request.getSession(false);

        Connection con = null;
        CallableStatement proc = null;
        String message = "";
        String pacsId = (String) session.getAttribute("pacsId");
        String user = (String) session.getAttribute("user");


       // String ServletName = request.getParameter("handle_id");

        BasicInformationBean BasicInformationBeanObj = new BasicInformationBean();


        if ("Create".equalsIgnoreCase(ServletName)) {

            try {
               // BeanUtils.populate(BasicInformationBeanObj, request.getParameterMap());
            } catch (IllegalAccessException ex) {
               // Logger.getLogger(BasicInformationServlet.class.getName()).log(Level.SEVERE, null, ex);
               System.out.println("Error occurred during processing.");
            } catch (InvocationTargetException ex) {
               // Logger.getLogger(BasicInformationServlet.class.getName()).log(Level.SEVERE, null, ex);
               System.out.println("Error occurred during processing.");
            }

            try {
                con = DbHandler.getDBConnection();
                try {
                    proc = con.prepareCall("{ call SHG_OPERATIONS.Upsert_basic_info(?,?,?,?,?,?,?,?,?) }");
                } catch (SQLException ex) {
                  //  Logger.getLogger(BasicInformationServlet.class.getName()).log(Level.SEVERE, null, ex);
                }
                proc.setString(1, BasicInformationBeanObj.getShgcode());
                proc.setString(2, BasicInformationBeanObj.getNameOfShg());
                proc.setString(3, BasicInformationBeanObj.getGroupCategory());
                proc.setString(4, BasicInformationBeanObj.getDateOfFormation());
                proc.setString(5, BasicInformationBeanObj.getDuration());
                proc.setString(7, BasicInformationBeanObj.getCif());
                proc.setString(8,pacsId );

                proc.setString(6, ServletName);

                proc.registerOutParameter(9, java.sql.Types.VARCHAR);

                proc.execute();

                //message = proc.getString(9);

            } catch (SQLException ex) {
               // Logger.getLogger(BasicInformationServlet.class.getName()).log(Level.SEVERE, null, ex);
               System.out.println("Error occurred during processing.");
            } finally {
                try {
                    proc.close();
                } catch (SQLException e) {
                    System.out.println("Error occurred during procedure close.");
                }
                try {
                    con.close();
                } catch (SQLException ex) {
                   // Logger.getLogger(BasicInformationServlet.class.getName()).log(Level.SEVERE, null, ex);
                   System.out.println("Error occurred during connection close.");
                }

                request.setAttribute("message", message);
                request.getRequestDispatcher("/Shg_JSP/BasicInformation.jsp").forward(request, response);

            }

        } else if ("Search".equalsIgnoreCase(ServletName)) {

            try {
              //  BeanUtils.populate(BasicInformationBeanObj, request.getParameterMap());
            } catch (IllegalAccessException ex) {
               // Logger.getLogger(BasicInformationServlet.class.getName()).log(Level.SEVERE, null, ex);
               System.out.println("Error occurred during processing.");
            } catch (InvocationTargetException ex) {
               // Logger.getLogger(BasicInformationServlet.class.getName()).log(Level.SEVERE, null, ex);
               System.out.println("Error occurred during processing.");
            }

            Connection connection = null;
            ResultSet resultset = null;
            Statement statement = null;
            connection = DbHandler.getDBConnection();
            int SeachFound = 0;

            try {
                statement = connection.createStatement();
            } catch (SQLException ex) {
               // Logger.getLogger(BasicInformationServlet.class.getName()).log(Level.SEVERE, null, ex);
               System.out.println("Error occurred during processing.");
            }
            try {

                //ResultSet rs = statement.executeQuery("select NAME_OF_SHG, GRP_CATEGORY, to_char(DATE_OF_FORMATION,'DD/MM/RRRR') as DATE_OF_FORMATION , DURATION, SHG_CODE,CIF from BASIC_INFO where SHG_CODE= '" + BasicInformationBeanObj.getShgSearch() + "' and pacs_id = '" +pacsId+ "' ");

                while (rs.next()) {
                    BasicInformationBeanObj = new BasicInformationBean();
                    BasicInformationBeanObj.setNameOfShg(rs.getString("NAME_OF_SHG"));
                    BasicInformationBeanObj.setGroupCategory(rs.getString("GRP_CATEGORY"));
                    BasicInformationBeanObj.setDateOfFormation(rs.getString("DATE_OF_FORMATION"));
                    BasicInformationBeanObj.setDuration(rs.getString("DURATION"));
                    BasicInformationBeanObj.setShgcode(rs.getString("SHG_CODE"));
                    BasicInformationBeanObj.setCif(rs.getString("CIF"));


                    SeachFound = 1;
                    request.setAttribute("displayFlag", "Y");

                }

               // statement.close();
               // connection.close();

            } catch (SQLException ex) {
               // Logger.getLogger(BasicInformationServlet.class.getName()).log(Level.SEVERE, null, ex);
               System.out.println("Error occurred during processing.");
            } finally {
                try {
                    if(statement !=null)
                        statement.close();
                    if (connection != null)
                    connection.close();

            } catch (Exception e) {               
               System.out.println("Error Occurred during connection close.");
            }

            }

            if (SeachFound == 0) {
                message = "SHG Code does not exist in the system";
                request.setAttribute("message", message);
            }
            request.setAttribute("BasicInformationBeanObj", BasicInformationBeanObj);

            request.getRequestDispatcher("/Shg_JSP/BasicInformation.jsp").forward(request, response);

        } else if ("Update".equalsIgnoreCase(ServletName)) {

            try {
               // BeanUtils.populate(BasicInformationBeanObj, request.getParameterMap());
            } catch (IllegalAccessException ex) {
               // Logger.getLogger(BasicInformationServlet.class.getName()).log(Level.SEVERE, null, ex);
               System.out.println("Error occurred during processing.");
            } catch (InvocationTargetException ex) {
               // Logger.getLogger(BasicInformationServlet.class.getName()).log(Level.SEVERE, null, ex);
               System.out.println("Error occurred during processing.");
            }

            try {
                con = DbHandler.getDBConnection();
                try {
                    proc = con.prepareCall("{ call SHG_OPERATIONS.Upsert_basic_info(?,?,?,?,?,?,?,?,?) }");
                } catch (SQLException ex) {
                   // Logger.getLogger(BasicInformationServlet.class.getName()).log(Level.SEVERE, null, ex);
                    System.out.println("Error occurred during processing.");
                }

                proc.setString(1, BasicInformationBeanObj.getShgcodeAmend());
                proc.setString(2, BasicInformationBeanObj.getNameOfShgAmend());
                proc.setString(3, BasicInformationBeanObj.getGroupCategoryAmend());
                proc.setString(4, BasicInformationBeanObj.getDateOfFormationAmend());
                proc.setString(5, BasicInformationBeanObj.getDurationAmend());
                proc.setString(7, BasicInformationBeanObj.getCifamend());
                proc.setString(8, pacsId);

                proc.setString(6, ServletName);


                proc.registerOutParameter(9, java.sql.Types.VARCHAR);

                proc.execute();

               

            } catch (SQLException ex) {
               // Logger.getLogger(BasicInformationServlet.class.getName()).log(Level.SEVERE, null, ex);
               System.out.println("Error occurred during processing.");
            } finally {
                try {
                    proc.close();
                } catch (SQLException e) {
                    System.out.println("Error occurred during procedure close.");
                }
                try {
                    con.close();
                } catch (SQLException ex) {
                   // Logger.getLogger(BasicInformationServlet.class.getName()).log(Level.SEVERE, null, ex);
                   System.out.println("Error occurred during connection close.");
                }

                request.setAttribute("message", message);
                request.getRequestDispatcher("/Shg_JSP/BasicInformation.jsp").forward(request, response);

            }

        }

    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>
}
